<template>
  <b-overlay :show="overlayAccess" rounded="sm" variant="primary" spinner-type="" opacity="0.1" blur="2px">
   <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
    <ValidationObserver v-slot="{ invalid }">
      <div class="card-body">
        <div class="col-md-12">
          <b-row class="form-group mt-10">
            <b-col md="12" class="text-center">
              <!-- <div class="alert alert-custom alert-default" role="alert">
                 <div class="alert-icon">
                                     <span class="svg-icon svg-icon-primary svg-icon-xl">
                                       &lt;!&ndash;begin::Svg Icon | path:/metronic/theme/html/demo1/dist/assets/media/svg/icons/Tools/Compass.svg&ndash;&gt;
                                       <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
                                            width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                         <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                           <rect x="0" y="0" width="24" height="24"></rect>
                                           <path
                                               d="M7.07744993,12.3040451 C7.72444571,13.0716094 8.54044565,13.6920474 9.46808594,14.1079953 L5,23 L4.5,18 L7.07744993,12.3040451 Z M14.5865511,14.2597864 C15.5319561,13.9019016 16.375416,13.3366121 17.0614026,12.6194459 L19.5,18 L19,23 L14.5865511,14.2597864 Z M12,3.55271368e-14 C12.8284271,3.53749572e-14 13.5,0.671572875 13.5,1.5 L13.5,4 L10.5,4 L10.5,1.5 C10.5,0.671572875 11.1715729,3.56793164e-14 12,3.55271368e-14 Z"
                                               fill="#000000" opacity="0.1"></path>
                                           <path
                                               d="M12,10 C13.1045695,10 14,9.1045695 14,8 C14,6.8954305 13.1045695,6 12,6 C10.8954305,6 10,6.8954305 10,8 C10,9.1045695 10.8954305,10 12,10 Z M12,13 C9.23857625,13 7,10.7614237 7,8 C7,5.23857625 9.23857625,3 12,3 C14.7614237,3 17,5.23857625 17,8 C17,10.7614237 14.7614237,13 12,13 Z"
                                               fill="#000000" fill-rule="nonzero"></path>
                                         </g>
                                       </svg>
                                       &lt;!&ndash;end::Svg Icon&ndash;&gt;
                                     </span>
                 </div>
                 <div class="alert-text">The example form below demonstrates common HTML form elements that receive updated
                   styles from Bootstrap with additional classes.
                 </div>
              </div>-->
            </b-col>

            <b-col md="12">
              <label class="col-form-label text-lg-right text-left">
                عکس پرسنلی
                <span class="text-danger">*</span>
              </label>
              <div class="col-9">
                <div
                    class="image-input image-input-empty image-input-outline"
                    id="kt_user_edit_avatar"
                    :style="option && !uploadStatus?'background-image: url('+option.avatar+')':{ backgroundImage: `url(${backgroundUrl})` }"
                >
                  <div class="image-input-wrapper"></div>

                  <label
                      class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                      data-action="change"
                      data-toggle="tooltip"
                      title
                      data-original-title="تغییر عکس"
                  >
                    <i class="fa fa-pen icon-sm text-muted"></i>
                    <ValidationProvider rules="required|image" v-slot="{ errors }">
                      <input
                          type="file"
                          name="عکس پرسنلی"
                          @change="setFileInput"
                          accept=".png, .jpg, .jpeg"
                      />
                      <input type="hidden" name="profile_avatar_remove"/>
                      <span class="text-danger">{{ errors[0] }}</span>
                    </ValidationProvider>
                  </label>

                  <span
                      class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                      data-action="cancel"
                      data-toggle="tooltip"
                      title="Cancel avatar"
                  >
                  <i class="ki ki-bold-close icon-xs text-muted"></i>
                </span>

                  <span
                      :class="[uploadStatus ? 'd-block' : '','btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow']"
                      data-action="remove"
                      data-toggle="tooltip"
                      title="Remove avatar"
                      @click="removeUploadImage"
                  >
                  <i class="ki ki-bold-close icon-xs text-muted"></i>
                </span>
                </div>
              </div>
            </b-col>

            <!--<div class="col-12">
              <div class="form-group row">
                <div class="col-lg-9 col-xl-6">
                  <div class="image-input image-input-outline" id="kt_profile_avatar" :style="{ backgroundImage: `url(${backgroundUrl})` }">
                    <div class="image-input-wrapper" style="background-image: url(assets/media/users/300_21.jpg)"></div>
                    <label class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow" data-action="change" data-toggle="tooltip" title="" data-original-title="Change avatar">
                      <i class="fa fa-pen icon-sm text-muted"></i>
                      <ValidationProvider rules="required|image" v-slot="{ errors }">

                      <input type="file" name="عکس پرسنلی"
                             @change="setFileInput"
                             accept=".png, .jpg, .jpeg" />
                      <input type="hidden" name="profile_avatar_remove" />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </label>
                    <span class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow" data-action="cancel" data-toggle="tooltip" title="Cancel avatar">
                                    <i class="ki ki-bold-close icon-xs text-muted"></i>
                                  </span>
                    <span
                        :class="[uploadStatus ? 'd-block' : '','btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow']"
                        data-action="remove"
                        data-toggle="tooltip" title="Remove avatar"
                        @click="removeUploadImage">
                                              <i class="ki ki-bold-close icon-xs text-muted"></i>
                                          </span>
                  </div>
                  <span class="form-text text-muted">انواع فایل های مجاز: png ، jpg ، jpeg</span>
                </div>
              </div>
            </div>-->

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  نام
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                    <input
                        type="text"
                        class="form-control"
                        v-model="newPersonalProfile.name"
                        name="نام"
                        placeholder="مثلا : محمد"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  نام خانوادگی
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                    <input
                        type="text"
                        class="form-control"
                        v-model="newPersonalProfile.lastName"
                        name="نام خانوادگی"
                        placeholder="مثلا : نوری زاده"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  کدملی
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|digits:10" v-slot="{ errors }">
                    <input
                        type="text"
                        class="form-control"
                        v-model.trim="newPersonalProfile.nationalCode"
                        name="کدملی"
                        placeholder="مثلا : 2530000000"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group mt-md-3">
                <label>
                  تاریخ تولد
                  <span class="text-danger">*</span>
                </label>
                <ValidationProvider rules="required" v-slot="{ errors }">
                  <date-picker
                      v-if="DatePickerShow"
                      locale="fa"
                      format="YYYY/M/D"
                      v-model="newPersonalProfile.birthday"
                      :auto-submit="true"
                      display-format="dddd jDD jMMMM jYYYY"
                      placeholder="مثلا : 1376/04/19"
                  />
                  <span class="text-danger">{{ errors[0] }}</span>
                </ValidationProvider>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  پست الکترونیک
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required" v-slot="{ errors }">
                    <input
                        type="email"
                        class="form-control"
                        v-model="newPersonalProfile.email"
                        placeholder="مثلا : example@emailserver.com "
                        name="پست الکترونیک"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  شماره تماس منزل
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|digits:11" v-slot="{ errors }">
                    <input
                        type="text"
                        class="form-control"
                        v-model="newPersonalProfile.homeNumber"
                        name="شماره تماس منزل"
                        placeholder="مثلا : 0714452222"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  استان محل زندگی
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required" v-slot="{ errors }">
                    <select
                        class="form-control"
                        v-model="newPersonalProfile.state"
                        name="استان محل زندگی"
                        @change="setCity"
                    >
                      <option
                          v-for="state in states"
                          :value="state"
                          v-bind:key="state.id"
                      >{{ state.name }}
                      </option>
                    </select>
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  شهر محل زندگی
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required" v-slot="{ errors }">
                    <select
                        class="form-control"
                        v-model="newPersonalProfile.city"
                        name="شهر محل زندگی"
                        :disabled="disableSelectStatus"
                    >
                      <option
                          v-for="city in cities"
                          :value="city"
                          v-bind:key="city.id"
                      >{{ city.name }}
                      </option>
                    </select>
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  آدرس
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|min:5" v-slot="{ errors }">
                    <input
                        type="text"
                        class="form-control"
                        v-model="newPersonalProfile.address"
                        name="آدرس"
                        placeholder="مثلا : خیابان امام حسن مجتبی (ع)،پلاک 100"
                    />
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>

            <b-col md="4">
              <label class="col-form-label text-lg-right text-left">
                جنسیت
                <span class="text-danger">*</span>
              </label>
              <div class="form-group row">
                <div class="col-9 col-form-label">
                  <div class="radio-inline">
                    <label class="radio radio-primary">
                      <input
                          type="radio"
                          name="جنسیت"
                          v-model="newPersonalProfile.gender"
                          @click="checkGender"
                          value="مرد"
                      />
                      <span class="mx-3"></span>مرد
                    </label>
                    <label class="radio radio-primary">
                      <input
                          type="radio"
                          name="جنسیت"
                          v-model="newPersonalProfile.gender"
                          @click="checkGender"
                          value="زن"
                      />
                      <span class="mx-3"></span>زن
                    </label>
                  </div>
                </div>
              </div>
            </b-col>

            <b-col md="4" v-if="newPersonalProfile.gender=='مرد'">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  وضعیت نظام وظیفه
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required|min:2" v-slot="{ errors }">
                    <select
                        class="form-control"
                        v-model="newPersonalProfile.dutyStatus"
                        name="وضعیت نظام وظیفه"
                    >
                      <option value="پایان خدمت">پایان خدمت</option>
                      <option value="معافیت دائم">معافیت دائم</option>
                      <option value="معافیت تحصیلی">معافیت تحصیلی</option>
                      <option value="در حال انجام">در حال انجام</option>
                      <option value="مشمول">مشمول</option>
                    </select>
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>
          </b-row>

          <b-row>
            <b-col md="12">
              <div class="form-group">
                <label>درباره من</label>
                <ValidationProvider rules="required" v-slot="{ errors }">
                <textarea
                    class="form-control"
                    rows="4"
                    style="margin-top: 0px; margin-bottom: 0px; height: 96px;"
                    placeholder="از شخصیت و ویژگی‌های حرفه‌ای و شخصی خود بنویسید..."
                    v-model="newPersonalProfile.aboutMe"
                    name="درباه من"
                ></textarea>
                  <span class="text-danger">{{ errors[0] }}</span>
                </ValidationProvider>
              </div>
            </b-col>
          </b-row>
        </div>
        <div class="d-flex flex-column text-md-center">
        <span id="disabled-wrapper" tabindex="-5">
          <button
              v-if="invalid || overlayAccess"
              type="button"
              :disabled="true"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
          <button
              v-else
              @click="nextStep()"
              type="button"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
        </span>
          <b-tooltip
              v-if="invalid"
              target="disabled-wrapper"
          >تا زمانی که همه ی فیلد ها تکمیل نشوند این دکمه فعال نمی شود
          </b-tooltip>
        </div>
      </div>
    </ValidationObserver>
  </b-overlay>
  </b-overlay>
</template>

<script>
import backgroundUrlDefualt from "~/assets/media/users/blank.png";
import {ValidationObserver, ValidationProvider} from "vee-validate";
import gql from "graphql-tag";
import personalInformation from "~/apollo/mutation/resume/personalInformation.gql";

export default {
  props: ["option"],
  name: "Personal",
  components: {
    DatePicker: () => import("vue-persian-datetime-picker"),
    ValidationObserver,
    ValidationProvider,
  },
  data() {
    return {
      backgroundUrl: null,
      newPersonalProfile: {
        birthday: Date.now(),
        gender: "مرد",
      },
      now: Date.now(),
      uploadStatus: false,
      DatePickerShow: false,
      errors: null,
      states: [],
      cities: [],
      disableSelectStatus: true,
      maleGender: false,
      overlay: false,
      overlayAccess: false,
      avatar_url: null,
    };
  },
  async mounted() {
    this.backgroundUrl = backgroundUrlDefualt;
    this.DatePickerShow = true;
    let state = await this.$content("ostan").fetch();
    this.states = state.body;
    if (this.option) {
      if (this.option.ConfirmationStatus!=="Filling"){
        this.overlayAccess=true;
      }
      if (this.avatar_url==null){
        this.avatar_url=this.option.avatar;
      }
      if (this.option.state) {
        delete this.option.state.__typename;
      }
      if (this.option.city) {
        delete this.option.city.__typename;
      }
     this.newPersonalProfile = this.option;
      if (this.newPersonalProfile.state){
        await this.setCity();
      }
    }
  },
  methods: {
    removeUploadImage() {
      this.backgroundUrl = backgroundUrlDefualt;
      this.uploadStatus = false;
      this.newPersonalProfile.avatar = null;
    },

    setFileInput(event) {
      if (Object.values(event.target.files).length) {
        this.newPersonalProfile.avatar = event.target.files[0];
        this.backgroundUrl = URL.createObjectURL(event.target.files[0]);
        this.filename = event.target.files[0].name;
        this.uploadStatus = true;
      }
    },

    async setCity() {
      let iran_cities = await this.$content("shahrestan").fetch();
      this.cities = iran_cities.body.filter(
          (x) => x.ostan === this.newPersonalProfile.state.id
      );
      this.disableSelectStatus = false;
    },

    checkGender(gender) {
      gender.target.value === "مرد"
          ? (this.maleGender = true)
          : (this.maleGender = false);
    },

    alert(title, text, icon) {
      Swal.fire({
        title: title,
        text: text,
        icon: icon,
        confirmButtonText: "باشه",
      });
    },
    nationalCodeValidation(nationalCode) {
      if (nationalCode.length == 10) {
        if (
            nationalCode == "1111111111" ||
            nationalCode == "0000000000" ||
            nationalCode == "2222222222" ||
            nationalCode == "3333333333" ||
            nationalCode == "4444444444" ||
            nationalCode == "5555555555" ||
            nationalCode == "6666666666" ||
            nationalCode == "7777777777" ||
            nationalCode == "8888888888" ||
            nationalCode == "9999999999"
        ) {
          return false;
        }
        let c = parseInt(nationalCode.charAt(9));
        let n =
            parseInt(nationalCode.charAt(0)) * 10 +
            parseInt(nationalCode.charAt(1)) * 9 +
            parseInt(nationalCode.charAt(2)) * 8 +
            parseInt(nationalCode.charAt(3)) * 7 +
            parseInt(nationalCode.charAt(4)) * 6 +
            parseInt(nationalCode.charAt(5)) * 5 +
            parseInt(nationalCode.charAt(6)) * 4 +
            parseInt(nationalCode.charAt(7)) * 3 +
            parseInt(nationalCode.charAt(8)) * 2;
        let r = n - parseInt(n / 11) * 11;
        if (
            (r == 0 && r == c) ||
            (r == 1 && c == 1) ||
            (r > 1 && c == 11 - r)
        ) {
          return true;
        } else {
          return false;
        }
      } else {
        return false;
      }
    },
    nextStep() {
      var date1 = new Date(this.newPersonalProfile.birthday);
      var birthday = moment(date1).format("YYYYMMDD");
      var date_now = moment(new Date()).format("YYYYMMDD");
      let error = false;
      if (birthday >= date_now) {
        this.alert("تاریخ تولد", "تاریخ تولد را درست وارد کنید", "warning");
        error = true;
      }
      if (!this.nationalCodeValidation(this.newPersonalProfile.nationalCode)) {
        this.alert("کدملی", "کد ملی را درست وارد کنید", "warning");
        error = true;
      }
      if (!this.option) {
        if (!this.uploadStatus) {
          this.alert("عکس پرسنلی", "عکس پرسنلی را وارد کنید", "warning");
          error = true;
        }
      }
      if (!error) {
        this.savePersonal();
      }
    },
    async savePersonal() {
      let self = this;
      self.overlay = true;
      let variables = {
        avatar: self.newPersonalProfile.avatar,
        avatar_url: self.avatar_url,
        name: self.newPersonalProfile.name,
        lastName: self.newPersonalProfile.lastName,
        nationalCode: self.newPersonalProfile.nationalCode,
        gender: self.newPersonalProfile.gender,
        email: self.newPersonalProfile.email,
        state: JSON.stringify(self.newPersonalProfile.state),
        city: JSON.stringify(self.newPersonalProfile.city),
        homeNumber: self.newPersonalProfile.homeNumber,
        address: self.newPersonalProfile.address,
        dutyStatus: self.newPersonalProfile.dutyStatus,
        aboutMe: self.newPersonalProfile.aboutMe,
        birthday: self.newPersonalProfile.birthday,
      };
      let mutation = gql`
        ${personalInformation}
      `;
      await this.$apollo
          .mutate({
            mutation,
            variables,
            context: {headers: {"x-token": this.$auth.getToken("local")}},
          })
          .then(({data}) => {
            self.overlay = false;
            Swal.close();
            if (data.personalInformation != null) {
              Swal.fire({
                title: "موفقیت آمیز",
                text: "اطلاعات با موفقیت ثبت شد.",
                icon: "success",
                confirmButtonText: "باشه"
              }).then((res) => {
                this.$emit('my-event', {step: 'personal', info: data.personalInformation})
              })
            }
          })
          .catch((err) => {
            self.overlay = false;
            Swal.close();
            let gqlError = err.graphQLErrors;
            if (gqlError.length > 0) {
              if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
                let self = this;
                console.log("please login");
                /* this.$auth.logout().then(res => {
                     self.$router.push("/login");
                   });*/
              }
            } else {
              Swal.fire({
                title: "خطا",
                text:
                    "مشکل در ارتباط، لطفا اتصال اینترنت خود را بررسی و سپس مجددا تلاش کنید",
                icon: "error",
                confirmButtonText: "باشه",
              });
            }
          });
    },
  },
};
</script>

<style scoped>
</style>